# -*- coding: utf-8 -*-
#%% Poglavje 7

import funkcije
import numpy as np
from matplotlib import pyplot as pp
from PIL import Image as im

I = np.array(im.open('./poglavje_7/preslikave_ct.png'))
fi = 10/180*np.pi
#%% Naloga 1
# V modulu funkcije ustvarimo funkcijo transformAffine2d.

# Naloga a)
# V modulu funkcije ustvarimo funkcijo ptTransform2d.

# Naloga b)
Y, X = np.meshgrid(np.arange(9), np.arange(12), indexing='ij')
T1 = funkcije.transformAffine2d(scale=[0.5, 0.5], trans=[10, 1],
                              rot=fi, shear=[0.25, 0.5])
Xt1, Yt1 = funkcije.ptTransform2d(T1, X, Y)

pp.figure()
pp.plot(X.flatten(), Y.flatten(), 'rx',
        label='Referenčne')
pp.plot(Xt1.flatten(), Yt1.flatten(), 'bx',
        label='Preslikane')
pp.legend(loc='upper left')
pp.show()
#%% Naloga 2
# V modulu funkcije ustvarimo funkcijo imTransform12d.

# Naloga a)
It = funkcije.imTransform2d(I, T1)

# Naloga b)
# V modulu funkcije ustvarimo funkcijo imRotate2d.

Ir = funkcije.imRotate2d(I, fi)

pp.figure()

funkcije.imShowEx(I, subplot=131, title='Izvirna')
funkcije.imShowEx(It, subplot=132, title='Transformirana')
funkcije.imShowEx(Ir, subplot=133, title='Rotirana')

pp.show()
